import 'package:flutter/material.dart';

class Tile {
  final Image image;
  final double size;
  final int currentCol;
  final int currentRow;
  final int originalCol;
  final int originalRow;

  Tile(
    @required this.image,
    @required this.size,
    @required this.currentCol,
    @required this.currentRow,
    @required this.originalCol,
    @required this.originalRow,
  );

  Container _tileWidget() {
    return Container(
      decoration: BoxDecoration(
        color: Colors.black,
        border: Border.all(
          color: Colors.black,
          width: 1,
        ),
      ),
      child: Image(
        image: this.image.image,
        width: this.size,
        height: this.size,
        fit: BoxFit.fill
      ),
    );
  }

  Container widget() {
    return Container(
      child: DragTarget<List<int>>(
        builder: (
          BuildContext context,
          List<dynamic> accepted,
          List<dynamic> rejected,
        ) {
          return Container(
            height: this.size,
            width: this.size,
            color: Colors.cyan,
            child: Draggable<List<int>>(
              data: [
                this.currentCol,
                this.currentRow,
              ],

              // Widget when draggable is stationary
              child: this._tileWidget(),

              // Widget when draggable is being dragged
              feedback: this._tileWidget(),

              // Widget to display on original place when being dragged
              childWhenDragging: Container(
                height: this.size,
                width: this.size,
                color: Colors.pinkAccent,
              ),
            ),
          );
        },
        onAccept: (List<int> data) {
          print(data.toString());
        },
      )
    );
  }
}
